﻿// セル内の文字が特定の文字列の場合に、セルの塗りを設定するスクリプト

if (app.documents.length < 1) {
	alert("ドキュメントを開いてください");
	exit();
}

var cset = [];
var tmp, i;
var doc = app.activeDocument;
var sws = doc.swatches;

//定義ファイルの読み込み
var iniFile = File.openDialog("設定ファイルを指定してください");
if (iniFile == null) {
	alert("キャンセルされました");
	exit();
}
iniFile.open("r");
while (!iniFile.eof){
	tmp = iniFile.readln().split("\t");
	tmp[0] = tmp[0].replace(/^\s+/, "").replace(/\s+$/, "");
	if (tmp[0] != "" && tmp[0].slice(0, 1) != "#") {
		tmp[1] = tmp[1].replace(/^\s+/, "").replace(/\s+$/, "");
		cset.push([tmp[0], tmp[1]]);
	}
}
iniFile.close();
//スウォッチの確認
tmp = "";
for (i = 0; i < cset.length; i++) {
	if (!sws.itemByName(cset[i][1]).isValid) {
		tmp += cset[i][1] + "\r";
	}
}
if (tmp != "") {
	alert("以下のスウォッチが見つかりません\r\r" + tmp +
		"\rドキュメントを確認するか、" + iniFile.name +
		"\rファイル中のスウォッチ名を確認してください");
	exit();
}
//選択状態の確認
var sel = doc.selection;
if (sel.length != 1) {
	alert("表のあるテキストフレームを1つ選択するか、\r" +
		"表内に文字カーソルを立ててください");
	exit();
}
//選択されているオブジェクト別に対象を特定して実行
switch (sel[0].constructor.name) {
	case "TextFrame":
		//ストーリー中の表全てを対象。テキストフレーム内に限定する場合はsel[0].tables
		var tbls = sel[0].parentStory.tables;
		if (tbls.length > 0) {
			for (i = 0; i < tbls.length; i++){
				cellcolor(tbls[i]);
			}
		} else {
			tmp = "notfound";
		}
		break;
	case "Table":
		cellcolor(sel[0]);
		break;
	case "Cell":
		cellcolor(sel[0].parent);
		break;
	case "Text":
	case "TextStyleRange":
	case "TextColumn":
	case "Paragraph":
	case "Line":
	case "Word":
	case "Character":
	case "InsertionPoint":
		if (sel[0].parent.constructor.name == "Cell") {
			cellcolor(sel[0].parent.parent);
		} else {
			tmp = "notfound";
		}
		break;
	default:
		tmp = "notfound";
}
//終了処理
if (tmp == "notfound") {
	alert("表は見つかりませんでした");
}

//セルに色を付ける
function cellcolor(targetTable) {
	var j, k;
	var ac = targetTable.cells;
	for (j = 0; j < ac.length; j++) {
		for (k = 0; k < cset.length; k++) {
			if (ac[j].contents == cset[k][0]) {
				ac[j].fillColor = sws.itemByName(cset[k][1]);
				break;
			}
		}
	}
}