﻿#targetengine "cellColorSession"

if (app.documents.length < 1) {
	alert("ドキュメントを開いてください");
	exit();
}

var cset = [];
var tmp, i;
var doc = app.activeDocument;
var sws = doc.swatches;
var sws0 = sws.itemByName("None");

//定義ファイルの読み込み
var iniFile = File.openDialog("設定ファイルを指定してください");
if (iniFile == null) {
	alert("キャンセルされました");
	exit();
}
iniFile.open("r");
while (!iniFile.eof){
	tmp = iniFile.readln().split("\t");
	tmp[0] = tmp[0].replace(/^\s+/, "").replace(/\s+$/, "");
	if (tmp[0] != "" && tmp[0].slice(0, 1) != "#") {
		tmp[1] = tmp[1].replace(/^\s+/, "").replace(/\s+$/, "");
		cset.push([tmp[0], tmp[1]]);
	}
}
iniFile.close();
//スウォッチの確認
tmp = "";
for (i = 0; i < cset.length; i++) {
	if (!sws.itemByName(cset[i][1]).isValid) {
		tmp += cset[i][1] + "\r";
	}
}
if (tmp != "") {
	alert("以下のスウォッチが見つかりません\r\r" + tmp +
		"\rドキュメントを確認するか、" + iniFile.name +
		"\rファイル中のスウォッチ名を確認してください");
	exit();
}

//イベントを追加
app.addEventListener(Event.AFTER_SELECTION_CHANGED, fillCellColor).name = "cellColorEvent";

function fillCellColor(ev){
	if (app.selection.length == 0) return;
	var parentObject = app.selection[0].parent;
	if (parentObject.constructor.name != "Cell") return;
	
	var filled = false;
	for (var k = 0; k < cset.length; k++) {
		if (parentObject.contents == cset[k][0]) {
			parentObject.fillColor = sws.itemByName(cset[k][1]);
			filled = true;
			break;
		}
	}
	if (!filled) parentObject.fillColor = sws0;
}

//ドキュメントを閉じるときに追加したイベントを削除（これをしないとエラーが出る）
app.addEventListener(Event.BEFORE_CLOSE, function (ev) {
	if (app.eventListeners.itemByName("cellColorEvent").isValid) {
		app.eventListeners.itemByName("cellColorEvent").remove();
	}
});